# Logistic Regression using R. 

# http://www.tatvic.com/blog/improving-prediction-model-of-whether-a-user-will-come-back-on-website-in-next-24-hours/

# Instructions
# -----------


# This file contains R code that helps you get started on logistic regression with R.
# We first recommend you to download sample dataset.  

# Set Wprking Directory, e.g. "D:/dir_name/......"
# Put the dat set in working directory
setwd("Your working direcory")

#Read the data
data_outlier_removed<-read.csv(file="sample_data_set.csv",head=TRUE, sep=',')

#Independent Varibles 
visitCount<- data_outlier_removed$visitCount
DaySinceLastVisit<- data_outlier_removed$DaySinceLastVisit
medium<-data_outlier_removed$medium
landingPagePath<-data_outlier_removed$landingPagePath
exitPagePath<-data_outlier_removed$exitPagePath
pageDepth<-data_outlier_removed$pageDepth

#Dependent variable
revisit<-data_outlier_removed$revisit

#Generating labels
l_landingPagePath<-rbind(levels(landingPagePath))
l_medium<-rbind(levels(medium))
l_exitPagepath<-rbind(levels(exitPagePath))

#Factoring variables
f.medium<-factor(medium,labels=l_medium)
f.landingPagePath<-factor(landingPagePath,labels=l_landingPagePath)
f.exitPagepath<-factor(exitPagePath,labels=l_exitPagepath)

#Create Contras matrix
contrasts(f.medium) = contr.treatment(length(levels(medium)))
contrasts(f.landingPagePath) = contr.treatment(length(levels(landingPagePath)))
contrasts(f.exitPagepath) = contr.treatment(length(levels(exitPagePath)))

#Create Model_1
Model_1 <- glm(revisit ~ DaySinceLastVisit + visitCount +f.medium +f.landingPagePath +f.exitPagepath+pageDepth, data=data_outlier_removed ,family = binomial("logit"))
summary(Model_1)

#Accuracy of the Model_1 after prediction
in_d <- data.frame( DaySinceLastVisit,visitCount,medium,landingPagePath,exitPagePath,pageDepth)
predicted_revisit<-round(predict(Model_3,in_d,type="response"))
confusion_matrix <- ftable(revisit, predicted_revisit)
accuracy <- sum(diag(confusion_matrix))/2292*100
accuracy
